using System;
using System.Collections.Specialized ;
using System.IO ;

namespace shobonjtag
{
	/// <summary>
	/// Xilinx .ucf sԍƃlbĝ̑ΉǂރNXB܂CȂB
	/// 
	/// t@C̍\Ă邱ƂOɂ͂ĂB
	/// ԂقƂǓǂ߂ȂƎv :-)
	/// </summary>
	public class TinyUcf
	{
		/// <summary>
		/// sԍƐM̂̎
		/// </summary>
		StringDictionary pinmap ;

		/// <summary>
		/// RXgN^
		/// </summary>
		public TinyUcf() {
		}

		/// <summary>
		/// ͌ʂ󂯎
		/// </summary>
		/// <returns></returns>
		public StringDictionary getPinmap() {
			return pinmap ;
		}

		/// <summary>
		/// pass ܂œǂݔ΂
		/// </summary>
		/// <returns></returns>
		private string pass_string(string pass,StreamReader sr) {
			string line = null ;
			while ((line = sr.ReadLine()) != null) {
				if (line.IndexOf(pass) >= 0) {
					break ;
				}
			}			
			return line ;
		}

		/// <summary>
		/// M̂ƃs̎쐬
		/// </summary>
		/// <param name="sr"></param>
		/// <returns></returns>
		private void create_PIN_MAP(StreamReader sr) {
			string line ;
			string pin ;
			string name ;
			pinmap = new StringDictionary() ;

			while ((line = sr.ReadLine()) != null) {

				line = line.Trim() ;
				if ((line.Length < 2) || (line[0] == '#')) continue ;
				
				// "NET" Ŏn܂ŝݑɂ
				int start = line.IndexOf("NET") ;
				if (start < 0) {
					continue ;
				}

				string[] param = line.Split(" ".ToCharArray(),20) ; // Ƃ肠PO܂ŁB
				for (int i=0;i<param.Length;i++) {
					// Ő󔒂폜
					param[i] = param[i].Trim() ;
				}

				for (int i=0,j=0;i<param.Length;i++) {
					// gȂg[N͖
					if (param[i] == "") {
						continue ;
					}
					param[j++] = param[i] ;
				}

				// sɒǉ
				// O͂QԖځBPLN^ڂƍŏILN^̓_uNI[gȂ̂Ŗ
				name = param[2-1].Substring(1,param[1].Length - 2) ;
				// s͂TԖځBPLN^ڂƍŏILN^̓_uNI[gȂ̂ŖA
				// QLN^ڂ 'P' W}Ȃ̂ō񖳎B
				pin  = param[5-1].Substring(2,param[4].Length - 3) ;
				//Console.WriteLine("pin["+pin+"]="+name) ;
				pinmap.Add(pin,name) ;			
			}			
		}

		/// <summary>
		/// NETLIST t@Cǂ
		/// </summary>
		/// <param name="filename"></param>
		public int readFile(string filename) {
			try {
				using (StreamReader sr = new StreamReader(filename)) {
					create_PIN_MAP(sr) ;
					if (pinmap.Count == 0) {
						// Ȃ
						return -1 ;
					}
					return 0 ;
				}
			} catch (Exception) {
				return -1 ;
			}
		}
	}
}
