using System;
using System.Collections ;
using System.Collections.Specialized ;

namespace shobonjtag
{
	/// <summary>
	/// foCXp[^`NX interface JtagDevice pč܂
	///
	/// xc95144_pq160 ̃foCXp[^`
	/// </summary>
	public class xc95144_pq160 : JtagDevice
	{
		/// <summary>
		/// tH[
		/// </summary>
		ViewForm vf ;

		/// <summary>
		/// CXgNVe[u
		/// </summary>
		static StringDictionary inst ;

		/// <summary>
		/// CXgNVe[u(Hashtable)ĕԂ
		/// </summary>
		/// <returns>e[û</returns>
		static StringDictionary CreateInstruction() {
			StringDictionary sd = new StringDictionary() ;

			//      "BYPASS ( 11111111)," &
			sd.Add( "BYPASS","11111111") ;
			//		"ISPEX ( 11110000)," &
			sd.Add( "ISPEX","11110000") ;
			//		"EXTEST ( 00000000)," &
			sd.Add( "EXTEST","00000000") ;
			//		"FERASE ( 11101100)," &
			sd.Add( "FREASE","11101100") ;
			//		"FBULK ( 11101101)," &
			sd.Add( "FBULK","11101101") ;
			//		"FPGM ( 11101010)," &
			sd.Add( "FPGM","11101010") ;
			//		"FPGMI ( 11101011)," &
			sd.Add( "FPGMI","11101011") ;
			//		"FVFY ( 11101110)," &
			sd.Add( "FVFY","11101110") ;
			//		"FVFYI ( 11101111)," &
			sd.Add( "FVFYI","11101111") ;
			//		"HIGHZ ( 11111100)," &
			sd.Add( "HIGHZ","11111100") ;
			//		"IDCODE ( 11111110)," &
			sd.Add( "IDCODE","11111110") ;
			//		"INTEST ( 00000010)," &
			sd.Add( "INTEST","00000010") ;
			//		"ISPEN ( 11101000)," &
			sd.Add( "ISPEN","11101000") ;
			//		"SAMPLE ( 00000001)," &
			sd.Add( "SAMPLE","00000001") ;
			//		"USERCODE ( 11111101)" ;
			sd.Add( "USERCODE","11111101") ;

			return sd ;
		}

		public xc95144_pq160()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
			if (inst == null) {
				inst = CreateInstruction() ;
			}
		}

		#region JtagDevice o

		public String LSINAME {
			get {
				// TODO:  xc95144_pq160.LSINAME getter ǉ܂B
				return "XC95144(PQFP160)" ;
			}
		}

		public double TAP_SCAN_CLOCK {
			get {
				// TODO:  xc95144_pq160.TAP_SCAN_CLOCK getter ǉ܂B
				return 1.00e+07 ;
			}
		}

		public int INSTRUCTION_LENGTH {
			get {
				// TODO:  xc95144_pq160.INSTRUCTION_LENGTH getter ǉ܂B
				return 8 ;
			}
		}

		public StringDictionary INSTRUCTION_OPCODE {
			get {
				// TODO:  xc95144_pq160.INSTRUCTION_OPCODE getter ǉ܂B
				return inst ; // RXgN^łƍĕԂ
			}
		}

		public String INSTRUCTION_CAPTURE {
			get {
				// TODO:  xc95144_pq160.INSTRUCTION_CAPTURE getter ǉ܂B
				return "000XXX01" ;
			}
		}

		public int BOUNDARY_LENGTH {
			get {
				// TODO:  xc95144_pq160.BOUNDARY_LENGTH getter ǉ܂B
				return 432;
			}
		}

		public String GetInstruction(String instType) {
			return inst[instType] ;
		}

		public void showViewForm() {
			if (vf == null) {
				vf = new ViewForm(LSINAME) ; 
			}
			vf.Show() ;
		}

		public void disposeViewForm() {
			if (vf != null) {
				vf.Close() ;
				vf = null ;
			}
		}

		#endregion

		#region SignalListener o

		public void SendSignal(string signalvector) {
			if (vf != null) {
				SignalListener sl = vf as SignalListener;
				sl.SendSignal(signalvector) ;
			}
		}

		#endregion
	}
}
